#define WIN32_LEAN_AND_MEAN
//#define UNICODE
//#define _UNICODE
#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <stdlib.h>
#include "NtCommon.h"
#include "NtCritical.h"

typedef HANDLE (WINAPI *TOpenThread)(DWORD, BOOL, DWORD);
typedef BOOL (WINAPI *TEnumProcesses)(PDWORD, DWORD, PDWORD);

#define MsgNotAvail _T("NtCritical functions are not available in this Windows version!")
#define tnot        _T(" not")
#define t0          _T("")

INT _tmain(int argc, TCHAR** argv) {
  DWORD itc;
  if((argc == 1) || (argc == 3))  {
    // filter out 9x, NT4:
    HMODULE hntdll;
    TOpenThread NtCrit_OpenThread;
    if(hntdll = GetModuleHandleW(L"KERNEL32.dll")) {
      if((NtCrit_OpenThread = (TOpenThread)GetProcAddress(hntdll, "OpenThread")) == NULL) {
        return(_tprintf(MsgNotAvail));
      }
    }
    // rule out 2K:
    if(IsThreadCritical(CurrentThread) == NTCRIT_NOT_SUPPORTED)
      return(_tprintf(MsgNotAvail));
        
    if((AdjustPrivProcess(SE_DEBUG_PRIVILEGE, TRUE) == APP_FAILED)) {
      _tprintf(_T("Required right not granted | Unable to enable/disable privilege!\n"));
    }
    
    if(argc == 1) {
      HMODULE hPsApi;
      if(hPsApi = LoadLibraryW(L"PSAPI.dll")) {
        TEnumProcesses NtCrit_EnumProcesses;
        if(NtCrit_EnumProcesses = (TEnumProcesses)GetProcAddress(hPsApi, "EnumProcesses")) {
          DWORD Pids[512]; // increase if you need more
          DWORD ReqBytes;
          if(NtCrit_EnumProcesses(Pids, sizeof(Pids), &ReqBytes)) {
            DWORD i;
            ReqBytes /= sizeof(DWORD);
            for(i = 0; i < ReqBytes; i++) {
              HANDLE hProcess;
              if(hProcess = OpenProcess(PROCESS_QUERY_INFORMATION, FALSE, Pids[i])) {
                _tprintf(_T("Process %04u = %#06x is%s critical.\n"), Pids[i], Pids[i],
                  IsProcessCritical(hProcess) == NTCRIT_IS_CRITICAL ? t0 : tnot);
              }
            }
          }
          else {
            _tprintf(_T("Unable to get process ids | Too many processes!"));
          }
        }
        else {
          _tprintf(_T("Unable to find EnumProcesses function!"));
        }
      }
      else {
        _tprintf(_T("Unable to load PSAPI.dll!"));
      }
    }

    if(argc == 3) {
      HANDLE hProcess = NULL, hThread = NULL;
      DWORD Xid = _tcstoul(argv[1], NULL, 0);
      if((hThread = NtCrit_OpenThread(THREAD_SET_INFORMATION, FALSE, Xid)) == NULL) {
        hProcess = OpenProcess(PROCESS_SET_INFORMATION, FALSE, Xid);
      }
      if(hThread || hProcess) {
        BOOL CrResult;
        BOOL Enable = (argv[2][0] | ' ') == 'e';
        if(hThread) {
          CrResult = SetThreadCritical(hThread, Enable);
        }
        else {
          CrResult = SetProcessCritical(hProcess, Enable);
        }
        if(CrResult) {
          _tprintf(_T("New status set."));
        }
        else {
          _tprintf(_T("Unable to set new status."));
        }
      }
      else {
        _tprintf(_T("Unable to open Xid!"));
      }
    }
  }
  else {
    _tprintf(_T("NtCritical [Xid e|d]"));
  }
  return(0);
}