
  #define NTCRIT_NOT_CRITICAL  (+0)
  #define NTCRIT_IS_CRITICAL   (+1)
  #define NTCRIT_CANNOT_GETSET (+2)
  #define NTCRIT_NOT_SUPPORTED (+3)

  #define ProcessCriticalInformation 0x1D
  #define ThreadCriticalInformation  0x12

  typedef (__stdcall *TNtQueryInformationProcess)(HANDLE, DWORD, PDWORD, DWORD, PDWORD);
  typedef (__stdcall *TNtQueryInformationThread)(HANDLE, DWORD, PDWORD, DWORD, PDWORD);
  typedef (__stdcall *TNtSetInformationProcess)(HANDLE, DWORD, PDWORD, DWORD);
  typedef (__stdcall *TNtSetInformationThread)(HANDLE, DWORD, PDWORD, DWORD);

  TNtQueryInformationProcess NtCrit_NtQueryInformationProcess;
  TNtSetInformationProcess   NtCrit_NtSetInformationProcess;
  TNtQueryInformationThread  NtCrit_NtQueryInformationThread;
  TNtSetInformationThread    NtCrit_NtSetInformationThread;


  BOOL __stdcall InitializeNtCrit() {
    HMODULE hntdll;
    static BOOL s_InitializeNtCrit_Inited = FALSE;
    static BOOL s_InitializeNtCrit_Available = FALSE;
    if(s_InitializeNtCrit_Inited) {
      return(s_InitializeNtCrit_Available);
    }
    else {
      if(hntdll = GetModuleHandleW(L"ntdll.dll")) {
        if(
          (NtCrit_NtQueryInformationProcess = (TNtQueryInformationProcess)GetProcAddress(hntdll, "NtQueryInformationProcess")) &&
          (NtCrit_NtSetInformationProcess   = (TNtSetInformationProcess)GetProcAddress(hntdll, "NtSetInformationProcess"))   &&
          (NtCrit_NtQueryInformationThread  = (TNtQueryInformationThread)GetProcAddress(hntdll, "NtQueryInformationThread"))  &&
          (NtCrit_NtSetInformationThread    = (TNtSetInformationThread)GetProcAddress(hntdll, "NtSetInformationThread"))    &&
          (GetProcAddress(hntdll, "RtlSetProcessIsCritical") != NULL)
        ) {
          s_InitializeNtCrit_Available = TRUE;
        }
      }
      s_InitializeNtCrit_Inited = TRUE;
    }
    return(s_InitializeNtCrit_Available);
  }

  DWORD __stdcall IsProcessCritical(HANDLE hProcess) {
    BYTE IsCritical[4];
    if(InitializeNtCrit()) {
      if(NtCrit_NtQueryInformationProcess(hProcess,
           ProcessCriticalInformation, (PDWORD)IsCritical, sizeof(IsCritical), NULL) >= 0) {
        return(IsCritical[0] == 0 ? NTCRIT_NOT_CRITICAL : NTCRIT_IS_CRITICAL);
      }
      else {
        return(NTCRIT_CANNOT_GETSET);
      }
    }
    else {
      return(NTCRIT_NOT_SUPPORTED);
    }
  }

  BOOL __stdcall SetProcessCritical(HANDLE hProcess, BOOL SetCritical) {
    if(InitializeNtCrit()) {
      if(NtCrit_NtSetInformationProcess(hProcess,
           ProcessCriticalInformation, &SetCritical, sizeof(SetCritical)) >= 0) {
        return(TRUE);
      }
      else {
        return(FALSE);
      }
    }
    else {
      return(FALSE);
    }
  }



  DWORD __stdcall IsThreadCritical(HANDLE hThread) {
    BYTE IsCritical[4];
    if(InitializeNtCrit()) {
      if(NtCrit_NtQueryInformationThread(hThread,
           ThreadCriticalInformation, (PDWORD)IsCritical, sizeof(IsCritical), NULL) >= 0) {
        return(IsCritical[0] == 0 ? NTCRIT_NOT_CRITICAL : NTCRIT_IS_CRITICAL);
      }
      else {
        return(NTCRIT_CANNOT_GETSET);
      }
    }
    else {
      return(NTCRIT_NOT_SUPPORTED);
    }
  }

  BOOL __stdcall SetThreadCritical(HANDLE hThread, BOOL SetCritical) {
    if(InitializeNtCrit()) {
      if(NtCrit_NtSetInformationThread(hThread,
           ThreadCriticalInformation, &SetCritical, sizeof(SetCritical)) >= 0) {
        return(TRUE);
      }
      else {
        return(FALSE);
      }
    }
    else {
      return(FALSE);
    }
  }
